SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: 'blueGhost wallType pacman spaceType ghostHouseDoorType leftTransporterType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest methodsFor: 'actors' stamp: 'GabrielFinkelstein 5/16/2012 19:55'!
blueGhost

	^blueGhost ! !

!PacManTest methodsFor: 'movements' stamp: 'GabrielFinkelstein 5/16/2012 20:14'!
down

	^0@ -1! !

!PacManTest methodsFor: 'construction block types' stamp: 'GabrielFinkelstein 5/16/2012 20:16'!
ghostHouseDoorType

	^ghostHouseDoorType.! !

!PacManTest methodsFor: 'tests' stamp: 'GabrielFinkelstein 5/16/2012 20:25'!
initialize

	blueGhost := BlueGhost new position: 0@0.
	wallType := WallType new.
	pacman := Pacman new position: 0@0.
	spaceType := SpaceType new.
	ghostHouseDoorType := GhostHouseDoorType new.
	leftTransporterType := LeftTransporterType new.! !

!PacManTest methodsFor: 'movements' stamp: 'GabrielFinkelstein 5/16/2012 19:57'!
left

	^-1@0! !

!PacManTest methodsFor: 'construction block types' stamp: 'GabrielFinkelstein 5/16/2012 20:25'!
leftTransporterType

	^leftTransporterType .! !

!PacManTest methodsFor: 'actors' stamp: 'GabrielFinkelstein 5/16/2012 20:01'!
pacman

	^pacman.! !

!PacManTest methodsFor: 'movements' stamp: 'GabrielFinkelstein 5/16/2012 19:58'!
right

	^1@0! !

!PacManTest methodsFor: 'construction block types' stamp: 'GabrielFinkelstein 5/16/2012 20:09'!
spaceType

	^spaceType.
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'GabrielFinkelstein 5/16/2012 20:14'!
up

	^0@1! !

!PacManTest methodsFor: 'construction block types' stamp: 'GabrielFinkelstein 5/16/2012 19:56'!
wallType

	^wallType ! !

Object subclass: #Actor
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Actor methodsFor: 'moving' stamp: 'GabrielFinkelstein 5/16/2012 20:54'!
moveIfBlueGhostTo: aPosition
! !

!Actor methodsFor: 'moving' stamp: 'GabrielFinkelstein 5/16/2012 20:54'!
moveIfPacmanTo: aPosition! !

!Actor methodsFor: 'getting' stamp: 'GabrielFinkelstein 5/16/2012 20:07'!
position

	^position! !

!Actor methodsFor: 'setting' stamp: 'GabrielFinkelstein 5/16/2012 20:07'!
position: aPosition

	position := aPosition.! !

Actor subclass: #BlueGhost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!BlueGhost methodsFor: 'moving' stamp: 'GabrielFinkelstein 5/16/2012 20:53'!
moveIfBlueGhostTo: aPosition

	position := aPosition.! !

Actor subclass: #Pacman
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Pacman methodsFor: 'moving' stamp: 'GabrielFinkelstein 5/16/2012 20:53'!
moveIfPacmanTo: aPosition

	position := aPosition.! !

Object subclass: #BlockType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!BlockType methodsFor: 'determiningPosition' stamp: 'GabrielFinkelstein 5/16/2012 20:08'!
nextPositionFor: anActor going: direction

	self subclassResponsibility ! !

BlockType subclass: #GhostHouseDoorType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostHouseDoorType methodsFor: 'determiningPosition' stamp: 'GabrielFinkelstein 5/16/2012 20:52'!
nextPositionFor: anActor going: direction

	"( anActor isKindOf: BlueGhost ) ifTrue: [ ^anActor position + direction ] ifFalse: [ ^anActor position ]."
	anActor moveIfBlueGhostTo: anActor position + direction.
	^anActor position.! !

BlockType subclass: #LeftTransporterType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!LeftTransporterType methodsFor: 'determiningPosition' stamp: 'GabrielFinkelstein 5/16/2012 20:52'!
nextPositionFor: anActor going: direction

	"( anActor isKindOf: Pacman ) ifTrue: [ ^3@10 ] ifFalse: [ ^anActor position ]."
	anActor moveIfPacmanTo: 3@10.
	^anActor position.! !

BlockType subclass: #SpaceType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!SpaceType methodsFor: 'determiningPosition' stamp: 'GabrielFinkelstein 5/16/2012 20:13'!
nextPositionFor: anActor going: direction

	^anActor position + direction.! !

BlockType subclass: #WallType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!WallType methodsFor: 'determiningPosition' stamp: 'GabrielFinkelstein 5/16/2012 20:13'!
nextPositionFor: anActor going: direction

	^anActor position.! !
